// Ajay Tanwnani, 1st April 2016

#include "pbdlib/tpgmm.h"
#include "pbdlib/gmm.h"
#include "pbdlib/gmr.h"
#include "pbdlib/datapoints.h"
#include "pbdlib/tpdemonstration.h"
#include "pbdlib/taskparameters.h"
#include <sstream>

using namespace pbdlib;
using namespace std;

int main(int argc, char **argv){

	uint nbVarIn = 2;
	uint nbVarOut = 2;
	uint nbFrames = 1;
	uint nbVar;
	nbVar = nbVarIn + nbVarOut;

	TPGMM *tpgmm;
	TaskParameters *tp;
	GMM_Model *ProdGauss, *gmmOut, *gmmP;
	GMR *gmr;
	urowvec in, out;
	mat teleop_sigma;
	GaussianDistribution Teleop_Gauss(nbVarIn);

	int nbD = 100;
	colvec M_obj, M_teleop;
	mat S_obj, S_teleop;

	S_obj << 10000 << 100 << endr
	   	  << 100 << 10000;

	M_obj << 450 << 370;
	GaussianDistribution G1(M_obj,S_obj);

	S_teleop << 10000 << 100 << endr
	   	  << 100 << 10000;
	M_teleop << 120 << 390;

	GaussianDistribution G_obj(M_obj,S_obj);
	mat pos_obj = G_obj.stochasticSampling(nbD);

	GaussianDistribution G_teleop(M_teleop,S_teleop);
	mat pos_teleop = G_teleop.stochasticSampling(nbD/2);

	pos_teleop = join_rows(pos_obj.submat(0,0,1,pos_teleop.n_cols-1) + rand()%10, pos_teleop);

	std::vector<TPDemonstration> tpdemos;
	std::vector<TaskParameters> vTPs;
	std::vector<TaskParameter> cTaskParam;
	vector<mat> demos;
	mat demo;
	vector<mat> repros, robotRepros;

	tp = new TaskParameters(nbVar, nbFrames);
	for (int i=0; i<nbD; i++){
		TaskParameter tmpTp;
		for (int j=0; j < nbFrames; j++){
			tmpTp.A = eye(nbVar, nbVar);
			tmpTp.b = join_cols(zeros(nbVarIn,1), pos_obj.col(i));
			tp->setTaskParameters(j,tmpTp);
		}
		vTPs.push_back(*tp);
	}

	for (int i=0; i < nbD; i++){
//		vec tmpPoint = vTPs[i].getTaskParameters(0).A.i() *( join_cols(pos_teleop.col(i), pos_teleop.col(i)) - vTPs[i].getTaskParameters(0).b);
//		cout << tmpPoint << endl;
//		demo.insert_cols(i, tmpPoint);
		demo.insert_cols(i, join_cols(pos_teleop.col(i), pos_teleop.col(i)));
	}

	TPDemonstration tmpTpDemo(demo, vTPs);
	tpdemos.push_back(tmpTpDemo);

	mat tmpData = tpdemos[0].getDataInTaskParameters();

	tpgmm = new TPGMM(tpdemos, 2);
	tpgmm->initTensorGMM_kmeans();

	tpgmm->EM_tensorGMM();

//	tpgmm->estimateTensorGMM();
	cout << tpgmm->getNumFRAMES() << ",\t" << tpgmm->getNumVARS() << ",\t" << tpgmm->getNumSTATES() << endl;
}
